#ifndef MAGDATA_H
#define MAGDATA_H

#include "XMLFunctions.h"
#include "json_functions.h"

class MagData
{
public:
    MagData();
    void SetOpticData(double stdphase, double stdtrange, double stdmag);
    void SetGeomData(double rcs, double albedo);
    bool Load(myXML::Contain* parent);
    void load(const jsonval& parent);
    double GetMag() const { return m_mag; }
    double GetRcs() const { return m_rcs; }
    bool HasData() const { return m_hasData; }
    bool HasGeomData() const { return m_hasGeomData; }
    void CalcMag(double phase, double range);
    void CalcGeomMag(double phase, double range);
private:
    static double CalcA0g(double stdmag, double stdphase, double stdrange, double sunMag);
    static double CalcRealMag(double A0g, double sunMag, double phase, double range);

    double m_stdmag;
    double m_stdphase;
    double m_stdrange;
    double m_phase;
    double m_range;
    double m_mag;
    double m_rcs;
    double m_albedo;
    bool m_hasData;
    bool m_hasGeomData;
};

#endif
