#pragma once

#include "TM.h"
#include "DVectors.h"
#include "PhasePoint.h"

class GFCSRotator
{
public:
    GFCSRotator()
    {
    };
    GFCSRotator(TimeJD baseDate);
    void Init(TimeJD baseDate);
    void Rotate(TimeJD date, TransMtx& CJ2000toGFCS, TransMtx& CGFCStoJ2000) const;
    void J2000ToGCS(const PhasePoint6D& j2000, PhasePoint6D& gcs) const;
    void J2000ToGCS(TimeJD date, const Vect6& j2000, Vect6& gcs) const;
    void J2000ToLocalJ2000(TimeJD date, const Vect6& j2000, Vect3 siteGcsPos, Vect6& localJ2000) const;
    void J2000ToNze(TimeJD date, const Vect6& j2000, Vect3 siteGcsPos, Vect6& nze) const;
    void GCSToJ2000(const PhasePoint6D& gcs, PhasePoint6D& j2000) const;
    void GCSToJ2000(TimeJD date, const Vect6& gcs, Vect6& j2000) const;
private:
    void GetGcsToJ20006dConverter(TimeJD date, FrameConverter6D& gcsToJ2000) const;
    void GetJ2000ToGcs6dConverter(TimeJD date, FrameConverter6D& j2000ToGcs) const;
    void GetJ2000ToNze6dConverter(TimeJD date, Vect3 siteGcsPos, FrameConverter6D& gcsToJ2000) const;
    void GetJ2000ToLocalJ20006dConverter(TimeJD date, Vect3 siteGcsPos, FrameConverter6D& J2000toLocalJ2000) const;
    TransMtx BJ2000toGFCS;
    TimeJD m_baseDate;
};
