#pragma once

#include "StateVector.h"
#include "TM.h"
#include "ephi.h"
#include "DVectors.h"
#include "ires.h"

class XInterpolator
{
public:
    XInterpolator();
    XInterpolator(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end);
    XInterpolator(const std::vector<IRes>& vec);
    Vect6 get_pos(const TimeJD& date, bool tks = false) const;
    TimeJD get_beg() const { return m_beg; }
    TimeJD get_end() const { return m_end; }
    static void calc_positions(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, std::vector<IRes>& result);
    void export_data() const;
    std::vector<IRes> m_positions;
private:
    void create(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end);
    void create(const std::vector<IRes>& positions);
    static void propagate(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, int dir, std::vector<IRes>& result);
    static void propagate_dir(const SInitOrbit& orbit, const TimeJD& beg, const TimeJD& end, int dir, std::vector<IRes>& result);
    TimeJD m_beg;
    TimeJD m_end;
    ei m_ephi;
};
