#pragma once

#include "ITraject.h"
#include "orbBlocks.h"

class TrjInter : public ITraject
{
public:
    TrjInter(const OrbBlocksStore& orbit_processor);
    virtual bool Predict(const TimeJD& t, const IFrame& fr, Vect6& f);
    virtual bool PredictMatrix(const TimeJD& t, const IFrame& fr, Vect6& f, DMatrix& m);
    virtual bool Move(const TimeJD& t, DVector& u);
    virtual unsigned Size() const { return 6; }
    virtual bool Init(const DVector& u0);

    virtual void SetTime(const TimeJD& t)
    {
    }
    virtual const TimeJD& GetTime() const { return TimeJD(); };
    virtual IPredict* GetPredictor() { return 0; }
private:
    const OrbBlocksStore& m_orbit_processor;
};
